
#include <avr/io.h>
#include <avr/interrupt.h>

#include <util/delay.h>
#include <stdio.h>
#include <time.h> 
#include <stdlib.h>
#include <string.h>
#include "dht.h"
#include "usart.h"

#define dataPin 8;


#define DELAY_SECVENTA		250
#define NUM_SECVENTE		6

#define MORSE_LUNG		100
#define MORSE_SCURT		50
#define MORSE_PAUZA     50

#define NUM_NOTE		8
#define DURATA_NOTA		100


#define c 1915
#define D 1700
#define E 1519
#define F 1432
#define G 1275
#define A 1136
#define B 1014
#define C 956

#define PAUSE 0

#define PAUSE1 1500
#define PAUSE2 3000

#define duration1 300
#define duration2 600
#define duration3 5200
#define duration4 10400

#define pause1 500
#define pause2 1000
#define pause3 1500


#define PAUSE 0
#define TEMPO 300



void play_note(unsigned int note,int duration)
{
   // Reset the 16 bit Counter
   if(note != 0) {
	   TCNT1H = 0;
	   TCNT1L = 0;

	   // Set the Counter TOP
	   ICR1H = ( note >> 8 ) & 0x00FF;
	   ICR1L = note;

	   // Turn on the Prescaler
	   TCCR1B |= (1<<CS11);
	   switch(duration) {
		case 300:
			_delay_ms(duration1);
			break;
		case 600:
			_delay_ms(duration2);
			break;
		
	   }
		// Turn off the Prescaler
		   TCCR1B &= ~(1<<CS11);
		  _delay_ms(TEMPO);
	}else {
		switch(duration) {
		case 300:
			_delay_ms(duration1);
			break;
		case 600:
			_delay_ms(duration2);
			break;
		
	   }
		
	}		 
   
}

int main(void) {

	USART0_init();
	float first_temperature = 0;
	float hum = 0;
	dht_gettemperaturehumidity(&first_temperature, &hum);
	//printf("first_temperature: %.2f %f\n ",first_temperature,3.14);
	//DHT_Read(&first_temperature, &hum);
	float next_temperature = 0;
	uint32_t measure = 0;

	DDRA |= (1 << PA0);
	DDRA |= (1 << PA1);
	DDRA |= (1 << PA2);
	DDRA |= (1 << PA3);
	DDRA |= (1 << PA4);


	DDRC |= (1 << PC0);
	DDRC |= (1 << PC1);
	DDRC |= (1 << PC2);
	DDRC |= (1 << PC3);
	DDRC |= (1 << PC4);
	DDRC |= (1 << PC5);

	DDRD |= (1 << PD7);
	PORTD &=~(1 << PD7);


	 int age = 0;
	 int last_value = 1;

	 while(1){
 		 measure++;
		 if((PINB & (1 <<PB2)) == 0) {
 			age++;
 			last_value = 0;
 		 } 
 		if(age == 1) {
 			PORTC &= ~(1 << PC5);
 			PORTA |= (1 << PA4) | (1 << PA1)  | (1 << PA2)  | (1 << PA3) | (1 << PA0) ;
 			int i = 0;
 			while(i < 5){
		 		PORTA |= (1 << PA4) | (1 << PA1)  | (1 << PA2)  | (1 << PA3) | (1 << PA0) ;
				PORTC ^= (1 << PC5);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4) | (1 <<PC3);
				i++;

				_delay_ms(50);
			}
		} else if (age == 2) {
			int i = 0;
			while( i < 5) {
				PORTA = 0;
				PORTC = 1;
				PORTA |= (1 << PA0);
				PORTA |= (1 << PA2);
				PORTA |= (1 <<PA4);
				PORTC &= ~(1<<PC3);
				PORTC &= ~(1 <<PC4);
				PORTC &= ~(1 <<PC5);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2);
				_delay_ms(50);
				PORTA = 0;
				PORTC = 1;
				PORTC &= ~(1 <<PC5);
				PORTA |= (1 << PA1);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4) | (1 <<PC3);
			
				_delay_ms(50);
				PORTA = 0;
				PORTC = 1;
				PORTC &= ~(1 <<PC3);
				PORTA |= (1 << PA3);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4) | (1 <<PC5);
				_delay_ms(50);
				i++;
			}

	
		}	else if (age == 3) {
			int i = 0;
			while(i < 5) {
				PORTA = 0;
				PORTC = 1;
				PORTA |= (1 << PA0);
				PORTA |= (1 << PA2);
				PORTA |= (1 <<PA4);
				PORTC &= ~(1<<PC3);
				PORTC &= ~(1 <<PC4);
				PORTC &= ~(1 <<PC5);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2);
				_delay_ms(50);
				PORTA = 0;
				PORTC = 1;
				PORTC &= ~(1 <<PC5);
				PORTA |= (1 << PA1);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4) | (1 <<PC3);
			
				_delay_ms(50);
				PORTA = 0;
				PORTC = 1;
				PORTC &= ~(1 <<PC5);
				PORTA |= (1 << PA3);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4) | (1 <<PC3);
				_delay_ms(50);
				i++;
			}

	
		}
		else if (age == 4) {
			int i = 0;
			while(i < 5) {
				PORTA = 0;
				PORTC = 1;
				PORTA |= (1 << PA0) | (1 <<PA1);
				PORTC &= ~(1<<PC3);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4) | (1 << PC5);
				_delay_ms(50);
				PORTA = 0;
				PORTC = 1;
				PORTC &= ~(1 <<PC5);
				PORTC &= ~(1 <<PC4);
				PORTC &= ~(1 <<PC3);
				PORTA |= (1 << PA2);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2);
				_delay_ms(50);
				PORTA = 0;
				PORTC = 1;
				PORTC &= ~(1 <<PC5);
				PORTA |= (1 << PA3) | (1 << PA4) | (1 << PA2);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4) | (1 <<PC3);
				_delay_ms(50);
				i++;
			}

	
		}else if (age == 5) {
			int i = 0;
			while(i < 5) {
				PORTA = 0;
				PORTC = 1;
				PORTA |= (1 << PA0);
				PORTA |= (1 << PA2);
				PORTA |= (1 <<PA4);
				PORTC &= ~(1<<PC3);
				PORTC &= ~(1 <<PC4);
				PORTC &= ~(1 <<PC5);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2);
				_delay_ms(50);
				PORTA = 0;
				PORTC = 1;
				PORTC &= ~(1 <<PC3);
				PORTA |= (1 << PA1);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4) | (1 <<PC5);
			
				_delay_ms(50);
				PORTA = 0;
				PORTC = 1;
				PORTC &= ~(1 <<PC5);
				PORTA |= (1 << PA3);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4) | (1 <<PC3);
				_delay_ms(50);
				i++;		
			}


		}else if (age == 6) {
			int i = 0;
			while(i < 5) {
				PORTA = 0;
				PORTC = 1;
				PORTA |= (1 << PA0);
				PORTA |= (1 << PA2);
				PORTA |= (1 <<PA4);
				PORTC &= ~(1<<PC3);
				PORTC &= ~(1 <<PC4);
				PORTC &= ~(1 <<PC5);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2);
				_delay_ms(50);
				PORTA = 0;
				PORTC = 1;
				PORTC &= ~(1 <<PC3);
				PORTA |= (1 << PA1);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4) | (1 <<PC5);
			
				_delay_ms(50);
				PORTA = 0;
				PORTC = 1;
				PORTC &= ~(1 <<PC5);
				PORTA |= (1 << PA3);
				PORTC &= ~(1 <<PC3);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4) ;
				_delay_ms(50);

				i++;		
			}


		}else if (age == 7) {
			int i = 0;
			while(i < 5) {
				PORTA = 0;
				PORTC = 1;
				PORTA |= (1 << PA0);
				PORTA |= (1 << PA1);
				PORTA |= (1 <<PA2);
				PORTA |= (1 <<PA3);
				PORTA |= (1 <<PA4);
				PORTC &= ~(1 <<PC5);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2)| (1 << PC3) | (1 << PC4);
				_delay_ms(50);
				PORTA = 0;
				PORTC = 1;
				PORTC &= ~(1 <<PC3);
				PORTC &= ~(1 <<PC4);
				PORTC &= ~(1 <<PC5);
				PORTA |= (1 << PA0);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2);
			
				_delay_ms(50);
			

				i++;		
			}


		}else if (age == 8) {
			int i = 0;
			while(i < 5) {
				PORTA = 0;
				PORTC = 1;
				PORTA |= (1 << PA0);
				PORTA |= (1 << PA2);
				PORTA |= (1 <<PA4);
				PORTC &= ~(1<<PC3);
				PORTC &= ~(1 <<PC4);
				PORTC &= ~(1 <<PC5);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2);
				_delay_ms(50);
				PORTA = 0;
				PORTC = 1;
				PORTC &= ~(1 <<PC3);
				PORTC &= ~(1 <<PC5);
				PORTA |= (1 << PA1);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4) ;
			
				_delay_ms(50);
				PORTA = 0;
				PORTC = 1;
				PORTC &= ~(1 <<PC5);
				PORTA |= (1 << PA3);
				PORTC &= ~(1 <<PC3);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4) ;
				_delay_ms(50);

				i++;		
			}


		}
		else if (age == 9) {
			int i = 0;
			while(i < 5) {
				PORTA = 0;
				PORTC = 1;
				PORTA |= (1 << PA0);
				PORTA |= (1 << PA2);
				PORTA |= (1 <<PA4);
				PORTC &= ~(1<<PC3);
				PORTC &= ~(1 <<PC4);
				PORTC &= ~(1 <<PC5);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2);
				_delay_ms(50);
				PORTA = 0;
				PORTC = 1;
				PORTC &= ~(1 <<PC3);
				PORTC &= ~(1 <<PC5);
				PORTA |= (1 << PA1);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4) ;
			
				_delay_ms(50);
				PORTA = 0;
				PORTC = 1;
				PORTC &= ~(1 <<PC5);
				PORTA |= (1 << PA3);
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4) | (1 << PC3);
				_delay_ms(50);

				i++;		
			}


		}
		if(measure >= 4){
			dht_gettemperaturehumidity(&next_temperature, &hum);
		
			float diferenta = next_temperature - first_temperature;
			printf("first temperature ,next_temperature:, diferenta: %.2f %.2f %.2f %f\n ",
				first_temperature,next_temperature,diferenta,3.14);
			if(diferenta > 0.5) {
				//daca e foarte cald... 0.5 ...daca esti acasa... 1.5 merge ,
				//suflul e cam de 27 d grade 
	
				PORTC |= (1 <<PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4) | (1 << PC3) | (1 << PC5);
				PORTA &= ~(1 <<PA1);
				PORTA &= ~(1 <<PA2);
				PORTA &= ~(1 <<PA3);
				PORTA &= ~(1 <<PA4);
			
		   		DDRD = 0xFF;                  // Set PORTD as Output
		   		PORTD = 1<<PD7;
			   		 // Initial PWM (using Timer/Counter2)
			   TCCR2A=0b10000011;            // Fast PWM Mode, Clear on OCRA
			   TCCR2B=0b00000100;            // Used fclk/64 prescaler
			   OCR2A=0;                      // Initial the OC2A (PB3) Out to 0  

			   // Set ADMUX Channel for Volume
			   ADMUX=0x00;

			   // Initial the ADC Circuit
			   ADCSRA = (1<<ADEN) | (1<<ADPS2) | (1<<ADPS1);

			   // Free running Mode
			   ADCSRB = 0x00;

			   // Disable digital input on ADC0
			   DIDR0 = 0x01; 

			   // Set the Timer/Counter Control Register
			   TCCR1A = (1<<COM1A1)|(1<<COM1A0); // Set OC1A when up counting, clear when down counting
			   TCCR1B = (1<<WGM13);              // Phase/Freq-correct PWM, top value = ICR1


			   for(;;) {
		 		   // Start conversion by setting ADSC on ADCSRA Register
				   ADCSRA |= (1<<ADSC);

				   // wait until conversion complete ADSC=0 -> Complete
					   while (ADCSRA & (1<<ADSC));

				   // Get the 8 bit ADC Result
				   OCR1AH=0;
				   OCR1AL=ADCL;

		 		   // Display Clear, Home
				   play_note(c,1 * TEMPO);
				   play_note(c,1* TEMPO);
				   play_note(D,1* TEMPO);
				   play_note(c,1* TEMPO);
				   play_note(F,1* TEMPO);
				   play_note(E,1* TEMPO);
				   play_note(PAUSE,1 * TEMPO);

				   play_note(c,1 * TEMPO);
				   play_note(c,1* TEMPO);
				   play_note(D,1* TEMPO);
				   play_note(c,1* TEMPO);
				   play_note(G,1* TEMPO);
				   play_note(F,1* TEMPO);
				   play_note(PAUSE,1 * TEMPO);

				   play_note(c,1* TEMPO);
				   play_note(c,1* TEMPO);
				   play_note(C,1* TEMPO);
				   play_note(A,1* TEMPO);
				   play_note(F,1* TEMPO);
				   play_note(E,1* TEMPO);
				   play_note(D,1* TEMPO);
				   play_note(PAUSE,2 * TEMPO);

				   play_note(B,1* TEMPO);
				   play_note(B,1* TEMPO);
				   play_note(A,1* TEMPO);
				   play_note(F,1* TEMPO);
				   play_note(G,1* TEMPO);
				   play_note(F,1* TEMPO);
				   play_note(PAUSE,2 * TEMPO);
				}
			}
			measure = 0;
		}

	}
 
		return 0;
	}
